class People {
  constructor(name, age, sex) {
    this.name = name;
    this.age = age;
    this.sex = sex;
  }
  eat() {
    console.log("人可以吃东西！");
  }
  work() {
    if (this.sex === "man") {
      console.log("男人主要负责体力活！");
    } else {
      console.log("女人主要负责家庭生活！");
    }
  }
}

class Man extends People {
  constructor(name, age, sex, beard) {
    super(name, age, sex);
    this.beard = beard;
  }

  work = () => {
    console.log("男人主要负责体力活！");
  };
}

class Woman extends People {
  constructor(name, age, sex, hair) {
    super(name, age, sex);
    this.hair = hair;
  }

  work = () => {
    console.log("女人主要负责家庭生活！");
  };
}

const man = new Man("张三", 24, "男", "long beard");
man.eat(); // 人可以吃东西！
man.work(); // 男人主要负责体力活！
